SystemOrganization addCategory: #Familiar!

TestCase subclass: #FMFeatureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 10:59'!
testEquality

	| fm1 fm2 fm3 |
	fm1 := FMFeature new name: 'A'.
	fm2 := FMFeature new name: 'A'.
	fm3 := FMFeature new name: 'AA'.
	self assert: fm1 = fm2.
	self assert: fm1 ~~ fm2.
	
	self assert: fm1 ~= fm3.
	self assert: fm1 ~~ fm3.! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 11:00'!
testHash

	| fm1 fm2 fm3 |
	fm1 := FMFeature new name: 'A'.
	fm2 := FMFeature new name: 'A'.
	fm3 := FMFeature new name: 'AA'.
	self assert: fm1 hash = fm2 hash.
	
	self assert: fm1 hash ~= fm3 hash.
	! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 13:32'!
testMooseName

	| fm |
	fm := FMFeatureModel new.
	self assert: fm mooseName isString! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 13:35'!
testMooseName2

	| fm str |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B C [D];)'.
	self assert: fm mooseName isString.
	
	str := WriteStream on: String new.
	fm mooseNameOn: str.
	self assert: str contents isString! !

TestCase subclass: #FMImportCommandTest
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMImportCommandTest methodsFor: 'running' stamp: 'AlexandreBergel 7/1/2012 16:50'!
setUp

	command := FMImportCommand new.! !

!FMImportCommandTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 16:51'!
testIsParseable
	self assert: (command isParseable: 'foobar = FM (A : B C [D] ;)').
	"self deny: (command isParseable: 'foobar = FM ((A : B C [D] ;)')."! !

!FMImportCommandTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 14:39'!
testParse
	| model |
	model := command modelForTextualDescription: 'foobar = FM (A : B C [D] ;)'.
	self assert: (model class == MooseModel).
	
	self assert: (model allFeatureModels size = 1).
	self assert: (model allAssignments size = 1).
	self assert: (model allFeatures size = 4).
	self assert: (model allFeatures allSatisfy: [ :f | f featureModel notNil ]).
	self assert: (model allFeatureModels allSatisfy: [ :fm | fm features allSatisfy: [ :f | f featureModel == fm ] ] ).
	
	"self assert: (model allVariables) = {'foobar'}"
	! !

TestCase subclass: #FMParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

FMParserTest subclass: #FMASTBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMASTBuilderTest methodsFor: 'hooks' stamp: 'AlexandreBergel 7/1/2012 09:30'!
parser
	^ FMASTBuilder new! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 7/2/2012 15:04'!
source1

	^ 'source1 = FM (Source: Product TypeInfo Property;
			  Product: PictureAlbum;
			  PictureAlbum: Picasa;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: Selection [Secured];
			  Selection: (ByTag|ByUrl)+;)
			  
source2 = FM (Source: Product TypeInfo [Property];
			  Product: PictureAlbum;
			  PictureAlbum: Flickr;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: [Secured];)
			  
			  			  
source3 = FM (Source: Product TypeInfo;
			  Product: PictureAlbum;
			  PictureAlbum: PictureDir;
			  TypeInfo: Array;
			  Array: Picture;)
			  
source4 = FM (Source: Product TypeInfo [Property];
			  Product: Twitter;
			  TypeInfo: Array;
			  Array: Tweet;
			  Property: [Secured];)
			  
source5 = FM (Source: Product TypeInfo;
			  Product: NewsFeed;
			  TypeInfo: Array;
			  Array: News;)

			  			  
source6 = FM (Source: Product TypeInfo;
			  Product: Menu;
			  TypeInfo: MenuInfo;)
			  
source7 = FM (Source: Product TypeInfo Property;
			   Product: WeatherBug;
			   TypeInfo: Array;
			   Array: Weather;
			   Property: ForecastDelay;
			   ForecastDelay: (OneDay|ThreeDays|TenDays)+;)
		
source8 = FM (Source: Product TypeInfo;
			  Product: Announcer;
			  TypeInfo: Array;
			  Array: Annonce;)

source9 = FM (Source: Product TypeInfo;
			  Product: Calendar;
			  Calendar: (Agenda | HyperPlanning | GPU);
			  TypeInfo: Array;
			  Array: CalendarEvent;)
			  
source10 = FM (Source: Product TypeInfo;
			   Product: EmergencyManager;
			   TypeInfo: Array;
			   Array: Emergency;)

source11 = FM (Source: Product TypeInfo;
			   Product: ItemListSource;
			   TypeInfo: Array;
			   Array: Item;)			   
source12 = FM (Source: Product TypeInfo;
			   Product: Statistics;
			   TypeInfo: Array;
			   Array: Stat;)	
			    

test1 = FM (Root: Alarm Trigger;
			Trigger: Trigger_Date;)
			
test2 = FM(Racine: Tri Critere;
			Critere: Critere_Date Critere_Poids;)
			  '! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild1
	| c firstChild secondChild thirdChild |
	c := self parser child parse: 'B'.
	self assert: c isCollection.
	self assert: c first class == FMFeatureMendatory.
	self assert: c first feature = (FMFeature named: 'B')
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild2Multiple
	| c firstChild secondChild thirdChild |
	c := self parser children parse: 'B C D'.
	
	self assert: (c class == Array).
	self assert: (c allSatisfy: [ :cc | cc class ==  FMFeatureMendatory ]).
	self assert: c first feature name = 'B'.
	self assert: c second feature name = 'C'.
	self assert: c third  feature name = 'D'.
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild3
	| c thirdChild firstChild secondChild |
	c := self parser children parse: 'B (C | D)+'.
	self assert: c size = 3.

	firstChild := c first.
	self assert: firstChild class ==  FMFeatureMendatory.
	self assert: firstChild feature name = 'B'.
	
	secondChild := c second.
	self assert: secondChild class ==  FMFeatureOr.
	self assert: secondChild feature name = 'C'.
	
	thirdChild := c third.
	self assert: thirdChild class ==  FMFeatureOr.
	self assert: thirdChild feature name = 'D'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild4
	| c thirdChild firstChild secondChild |
	c := self parser children parse: '(C | D)+ B'.
	self assert: c size = 3.

	firstChild := c first.
	self assert: firstChild class == FMFeatureOr .
	self assert: firstChild feature name = 'C'.
	
	secondChild := c second.
	self assert: secondChild class ==  FMFeatureOr.
	self assert: secondChild feature name = 'D'.
	
	thirdChild := c third.
	self assert: thirdChild class ==  FMFeatureMendatory.
	self assert: thirdChild feature name = 'B'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild5
	| c thirdChild firstChild secondChild |
	c := self parser children parse: '(C | D)? B'.
	self assert: c size = 3.

	firstChild := c first.
	self assert: firstChild class == FMFeatureMutex .
	self assert: firstChild feature name = 'C'.
	
	secondChild := c second.
	self assert: secondChild class ==  FMFeatureMutex.
	self assert: secondChild feature name = 'D'.
	
	thirdChild := c third.
	self assert: thirdChild class ==  FMFeatureMendatory.
	self assert: thirdChild feature name = 'B'.
	
! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint1
	| c |
	c := self parser constraint parse: 'C | A'.
	self assert: c class == FMConstraintPipe.
	self assert: c right name = 'A'.
	self assert: c left name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint2
	| c |
	c := self parser constraint parse: 'C -> A'.
	self assert: c class == FMConstraintArrow.
	self assert: c right  name = 'A'.
	self assert: c left  name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint3
	| c |
	c := self parser constraint parse: 'C <-> A'.
	self assert: c class == FMConstraintEquiv.
	self assert: c right  name = 'A'.
	self assert: c left  name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint4
	| c |
	c := self parser constraint parse: 'C | A'.
	self assert: c class == FMConstraintPipe.
	self assert: c right  name = 'A'.
	self assert: c left  name = 'C'.! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/2/2012 11:07'!
testBuildingExample1

	| program assigment feature |
	program := self parser program parse: 'renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)'.
					
	self assert: (program class == FMProgram).
	self assert: (program numberOfStatements = 1).

	assigment := program statementAt: 1.
	self assert: (assigment variable = 'renderers11'). 
	
	feature := assigment featureModel.
	self assert: ((feature productionAt: 1) root name = 'Renderer').
	self assert: ((feature productionAt: 1) numberOfChildren = 3).
	
	self assert: (feature numberOfConstraints isZero).
	self assert: (feature numberOfProductions = 6).! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 11:07'!
testBuildingFeature1
	| c prod |
	c := self parser featureModel parse: 'FM ( A : B ; )'.
	self assert: c class == FMFeatureModel.
	self assert: c numberOfProductions = 1.
	self assert: c numberOfConstraints  isZero.
	
	prod := (c productionAt: 1).
	self assert: prod root name = 'A'.
	self assert: prod numberOfChildren = 1.
	 
	self assert: (prod childAt: 1 ) feature name = 'B' .! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 11:08'!
testBuildingFeature2
	| c prod |
	c := self parser featureModel parse: 'FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)'.
	self assert: c class == FMFeatureModel.
	self assert: c numberOfProductions = 6.
	self assert: c numberOfConstraints  isZero.
	
	prod := (c productionAt: 1).
	self assert: prod root name =  'Renderer'.
	self assert: prod numberOfChildren = 3.
	 
	prod := (c productionAt: 6).
	self assert: prod root name =  'CalendarRenderer'.
	self assert: prod numberOfChildren = 1.
	self assert: (prod childAt: 1) feature name = 'RenderCalendarDetail'.	! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingNegated
	| c |
	c := self parser constraint parse: '!! A'.
	self assert: c class == FMConstraintNegated.
	self assert: c expr name = 'A'! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingProduction1
	| c firstChild |
	c := self parser production parse: 'A : B'.
	self assert: c class == FMFeatureProduction.
	self assert: c root name = 'A'.
	self assert: c numberOfChildren = 1.

	firstChild := c childAt: 1.
	self assert: firstChild class ==  FMFeatureMendatory.! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingProduction2
	| c firstChild secondChild thirdChild |
	c := self parser production parse: 'A : B C D'.
	self assert: c class == FMFeatureProduction.
	self assert: c root name = 'A'.
	self assert: c numberOfChildren = 3.

	firstChild := c childAt: 1.
	secondChild := c childAt: 2.
	thirdChild := c childAt: 3.
	
	self assert: firstChild feature name = 'B'.
	self assert: secondChild class ==  FMFeatureMendatory.
	self assert: thirdChild class ==  FMFeatureMendatory.
	self assert: secondChild feature name = 'C'.
	self assert: thirdChild feature name  = 'D'.
	! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 11:48'!
testBuildingProduction3
	| c fourthChild |
	c := self parser production parse: 'A : B C D [E]'.
	self assert: c numberOfChildren = 4.

	fourthChild := c childAt: 4.
	
	self assert: fourthChild class ==  FMFeatureOptional.
	self assert: fourthChild feature name = 'E'.
	
	
	! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 12:36'!
testBuildingProduction4
	| c fourthChild firstChild secondChild |
	c := self parser production parse: 'A : (C | D | E | F) +'.
	self assert: c numberOfChildren = 4.

	firstChild := c childAt: 1.
	self assert: firstChild class ==  FMFeatureOr.
	self assert: firstChild feature name = 'C'.
	
	
	fourthChild := c childAt: 4.
	self assert: fourthChild class ==  FMFeatureOr.
	self assert: fourthChild feature name = 'F'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingProduction5
	| c thirdChild firstChild secondChild |
	c := self parser production parse: 'A : B (C | D)'.
	self assert: c numberOfChildren = 3.

	firstChild := c childAt: 1.
	self assert: firstChild class ==  FMFeatureMendatory.
	self assert: firstChild feature name = 'B'.
	
	secondChild := c childAt: 2.
	self assert: secondChild class ==  FMFeatureXor.
	self assert: secondChild feature name = 'C'.
	
	thirdChild := c childAt: 3.
	self assert: thirdChild class ==  FMFeatureXor.
	self assert: thirdChild feature name = 'D'.
	
! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 7/2/2012 11:30'!
testHierarchy1

	| fm firstFeature |
	fm := self parser featureModel parse: ' FM ( A : B C D; B : E; )'.
	
	self assert: fm numberOfProductions = 2.
	self assert: fm features = (#('A' 'B' 'C' 'D' 'E') collect: [ :n | FMFeature named: n] ).
	self assert: fm numberOfFeatures = 5.
	
	self assert: (fm subFeaturesOf: (FMFeature named: 'A')) = (#('B' 'C' 'D') collect: [ :n | FMFeature named: n] ).
	
	firstFeature := fm features first.
	self assert: firstFeature featureModel == fm.
	self assert: firstFeature subFeatures =  (#('B' 'C' 'D') collect: [ :n | FMFeature named: n] ).! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 7/2/2012 15:03'!
testHierarchy2

	| fm firstFeature |
	fm := self parser featureModel parse: ' FM ( Z : G; A : B ;)'.
	
	self assert: fm numberOfFeatures = 4.

	self assert: (fm featureNamed: 'A') subFeatures first ==   (fm featureNamed: 'B').
	self assert: (fm featureNamed: 'B') == fm features fourth.
	self assert: (fm featureNamed: 'B') subFeatures isEmpty 
! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 7/2/2012 15:05'!
testHierarchy3

	| program firstFeature |
	program := self parser program parse: self source1.

	self assert: (program featureNamed: 'Array') subFeatures first ==  (program featureNamed: 'Stat').
	self assert: (program featureNamed: 'Stat') subFeatures isEmpty 
! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/1/2012 16:30'!
testProgram
	| program |
	program := FMASTBuilder new program parse: 
'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)
					
renderers2 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Thumbnails;
					Product: AlbumRenderer;
					AlbumRenderer: ThumbnailsPicture;)
					
renderers3 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text [Graphic] Title Logo;
					Graphic: Full;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsDetails;)
					
renderers4 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsTitle;)	
					
renderers5 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetContent;)
					
renderers6 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text Graphic;
					Graphic: Thumbnails;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetFull;)
					
renderers7 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: FullscreenPicture;)
					
renderers8 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceTitle;)
					
renderers9 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers10 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)
					
renderers12 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarTitle;)
		
					
rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'.

	self assert: program numberOfStatements = 13.
	self assert: program lastStatement featureModel numberOfProductions = 11.
	self assert: program lastStatement featureModel numberOfConstraints = 52.! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/2/2012 12:38'!
testProgram2
	| fm |
	fm := FMASTBuilder new featureModel  parse: 
'FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'.

	self assert: fm notNil.
	self assert: fm numberOfProductions = 11.
	self assert: fm numberOfConstraints = 52.! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:45'!
parseFeatureModel: str
	self assert: (FMParser new featureModel matches: str).
	! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:48'!
parseProgram: str
	self assert: (FMParser new program matches: str).
	! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:47'!
parseStatement: str
	self assert: (FMParser new statement matches: str).
	! !

!FMParserTest methodsFor: 'hooks' stamp: 'AlexandreBergel 7/1/2012 09:24'!
parser
	^ FMParser new! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:24'!
testConstraint1
	self assert: (self parser constraint matches: 'C | A').! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testConstraint2
	self assert: (self parser constraint matches: '!! C | A').! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testConstraint3
	self assert: (self parser constraint matches: '(C | A)').! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample
	self assert: (self parser featureModel matches: 'FM (A : B C [D]; D : (E|F|G); C : (H|I|J)+ ;  C | I ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample10WithConstraint

	self assert: (self parser featureModel matches: 'FM (A : B ;  (RenderAnnonceTitle -> Text); (RenderAnnonceTitle -> Text);)')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample11WithConstraint

	self assert: (self parser featureModel matches: 'FM (A : B ;  (RenderAnnonceTitle -> Text); (Thumbnails -> !!RenderNewsTitle); )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample2
	self assert: (self parser featureModel matches: 'FM (A : B C [ D ] ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample3
	self assert: (self parser featureModel matches: 'FM ( A : B  ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample4
	self assert: (self parser featureModel matches: 'FM (A : B  C  ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample5
	self assert: (self parser featureModel matches: 'FM (A :  (B  | C); )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample6
	self assert: (self parser featureModel matches: 'FM (A :  (B  | C); A :  (B  | C);  )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample7
	self assert: (self parser featureModel matches: 'FM ( C : (H|I|J) + ;  )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample8WithConstraint
	self assert: (self parser featureModel matches: 'FM (A : B C [D]; D : (E|F|G); C : (H|I|J)+ ;  !! C | I ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:26'!
testExample9WithConstraint

	self assert: (self parser featureModel matches: 'FM (A : B ;  (RenderAnnonceTitle -> Text); )')! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:47'!
testExamples

	self parseStatement: 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)'! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:26'!
testIdentifier

	self assert: (self parser fmlIdentifier parse: 'HelloWorld') = 'HelloWorld'! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 14:12'!
testIdentifier2

	self assert: (self parser fmlIdentifier parse: 'Hello World') = 'Hello' ! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 10:24'!
testParsing

	| ast |
	ast := self parser program parse: 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)'.
					
	! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:26'!
testProduction
	self assert: (self parser production matches: 'A : B ')! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 09:12'!
testProgram
	self parseProgram: 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)
					
renderers2 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Thumbnails;
					Product: AlbumRenderer;
					AlbumRenderer: ThumbnailsPicture;)
					
renderers3 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text [Graphic] Title Logo;
					Graphic: Full;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsDetails;)
					
renderers4 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsTitle;)	
					
renderers5 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetContent;)
					
renderers6 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text Graphic;
					Graphic: Thumbnails;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetFull;)
					
renderers7 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: FullscreenPicture;)
					
renderers8 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceTitle;)
					
renderers9 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers10 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)
					
renderers12 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarTitle;)
		
					
rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 09:13'!
testProgram2
	self parseProgram: 'rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'! !

TestCase subclass: #FMVisitorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMVisitorTest methodsFor: 'source' stamp: 'AlexandreBergel 7/2/2012 13:17'!
program1

^ 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)
					
renderers2 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Thumbnails;
					Product: AlbumRenderer;
					AlbumRenderer: ThumbnailsPicture;)
					
renderers3 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text [Graphic] Title Logo;
					Graphic: Full;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsDetails;)
					
renderers4 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsTitle;)	
					
renderers5 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetContent;)
					
renderers6 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text Graphic;
					Graphic: Thumbnails;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetFull;)
					
renderers7 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: FullscreenPicture;)
					
renderers8 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceTitle;)
					
renderers9 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers10 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)
					
renderers12 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarTitle;)
		
					
rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)'! !

!FMVisitorTest methodsFor: 'source' stamp: 'AlexandreBergel 7/2/2012 13:19'!
program2

	^ 'source1 = FM (Source: Product TypeInfo Property;
			  Product: PictureAlbum;
			  PictureAlbum: Picasa;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: Selection [Secured];
			  Selection: (ByTag|ByUrl)+;)
			  
source2 = FM (Source: Product TypeInfo [Property];
			  Product: PictureAlbum;
			  PictureAlbum: Flickr;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: [Secured];)
			  
			  			  
source3 = FM (Source: Product TypeInfo;
			  Product: PictureAlbum;
			  PictureAlbum: PictureDir;
			  TypeInfo: Array;
			  Array: Picture;)
			  
source4 = FM (Source: Product TypeInfo [Property];
			  Product: Twitter;
			  TypeInfo: Array;
			  Array: Tweet;
			  Property: [Secured];)
			  
source5 = FM (Source: Product TypeInfo;
			  Product: NewsFeed;
			  TypeInfo: Array;
			  Array: News;)

			  			  
source6 = FM (Source: Product TypeInfo;
			  Product: Menu;
			  TypeInfo: MenuInfo;)
			  
source7 = FM (Source: Product TypeInfo Property;
			   Product: WeatherBug;
			   TypeInfo: Array;
			   Array: Weather;
			   Property: ForecastDelay;
			   ForecastDelay: (OneDay|ThreeDays|TenDays)+;)
		
source8 = FM (Source: Product TypeInfo;
			  Product: Announcer;
			  TypeInfo: Array;
			  Array: Annonce;)

source9 = FM (Source: Product TypeInfo;
			  Product: Calendar;
			  Calendar: (Agenda | HyperPlanning | GPU);
			  TypeInfo: Array;
			  Array: CalendarEvent;)
			  
source10 = FM (Source: Product TypeInfo;
			   Product: EmergencyManager;
			   TypeInfo: Array;
			   Array: Emergency;)

source11 = FM (Source: Product TypeInfo;
			   Product: ItemListSource;
			   TypeInfo: Array;
			   Array: Item;)			   
source12 = FM (Source: Product TypeInfo;
			   Product: Statistics;
			   TypeInfo: Array;
			   Array: Stat;)	
			      

test1 = FM (Root: Alarm Trigger;
			Trigger: Trigger_Date;)
			
test2 = FM(Racine: Tri Critere;
			Critere: Critere_Date Critere_Poids;)
			  '! !

!FMVisitorTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 13:21'!
testVisitor

	| visitorClasses |
	visitorClasses := FMVisitor withAllSubclasses.
	visitorClasses do: [ :vcls |
		#(#program1 #program2 ) do: [ :k | 
			(FMASTBuilder new program parse: (self perform: k)) accept: vcls new ] ] ! !

MPImportCommand subclass: #FMImportCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/2/2012 00:40'!
execute
	| str |
	str := UIManager default 
		multiLineRequest: 'Enter a program' initialAnswer: 'enter your Familiar program' answerHeight: 250.

	(str notNil and: [ str notEmpty ])
		ifTrue: [ MooseModel root add: (self modelForTextualDescription: str)  ]! !

!FMImportCommand methodsFor: 'util' stamp: 'AlexandreBergel 7/1/2012 16:48'!
isParseable: string
	^ FMASTBuilder new program matches: string! !

!FMImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/1/2012 16:44'!
label
	^ 'Import Familiar description from textual description'! !

!FMImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/2/2012 00:13'!
modelForTextualDescription: string
	"parse string and fill up a moose model. string has to correspond to a program"
	
	| model program collectingVisitor |
	
	"Make sure that the code is parseable"
	self assert: [ self isParseable: string ] description: 'Entered code is not parseable. Please check'.
	model := MooseModel new.
	
	program := FMASTBuilder new program parse: string.
	collectingVisitor := CollectingVisitor new.
	program accept: collectingVisitor.
	model addAll: collectingVisitor elements.
	
	^ model
	! !

MooseEntity subclass: #FMObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

FMObject subclass: #FMConstraintExpr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

FMConstraintExpr subclass: #FMConstraintBinOp
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

FMConstraintBinOp subclass: #FMConstraintAnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMConstraintAnd class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '&'! !

!FMConstraintAnd methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 13:27'!
accept: aVisitor
	aVisitor visitConstraintAnd: self! !

FMConstraintBinOp subclass: #FMConstraintArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMConstraintArrow class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '->'! !

!FMConstraintArrow methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 13:27'!
accept: aVisitor
	aVisitor visitConstraintArrow: self! !

!FMConstraintBinOp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 10:01'!
for: string
	"Return the class that correspond to the string. 
	We here assume that all the subclasses have a distint operator"
	^ self allSubclasses detect: [:cls | cls operator = string]! !

!FMConstraintBinOp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 10:00'!
operator
	^ self subclassResponsibility ! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:01'!
left
	^ left! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:01'!
left: anObject
	left := anObject! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:02'!
right
	^ right! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:02'!
right: anObject
	right := anObject! !

FMConstraintBinOp subclass: #FMConstraintEquiv
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMConstraintEquiv class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '<->'! !

!FMConstraintEquiv methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 13:27'!
accept: aVisitor
	aVisitor visitConstraintEquiv: self! !

FMConstraintBinOp subclass: #FMConstraintPipe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMConstraintPipe class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '|'! !

!FMConstraintPipe methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 13:28'!
accept: aVisitor
	aVisitor visitConstraintPipe: self! !

!FMConstraintExpr methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 13:27'!
accept: aVisitor
	self subclassResponsibility ! !

FMConstraintExpr subclass: #FMConstraintNegated
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMConstraintNegated methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 13:28'!
accept: aVisitor
	aVisitor visitConstraintNegated: self! !

!FMConstraintNegated methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:05'!
expr
	^ expr! !

!FMConstraintNegated methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:05'!
expr: anObject
	expr := anObject! !

FMConstraintExpr subclass: #FMConstraintValue
	instanceVariableNames: 'feature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMConstraintValue methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:06'!
feature
	^ feature! !

!FMConstraintValue methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:06'!
feature: anObject
	feature := anObject! !

FMObject subclass: #FMFeature
	instanceVariableNames: 'name featureModel subFeatures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMFeature class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/2/2012 11:01'!
named: aName
	^ self new name: aName; yourself! !

!FMFeature methodsFor: 'equality' stamp: 'AlexandreBergel 7/2/2012 11:00'!
= aFeature
	^ self name = aFeature name! !

!FMFeature methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:13'!
accept: aVisitor 
	aVisitor visitFeature: self! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:25'!
featureModel
	^ featureModel! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:25'!
featureModel: fm
	featureModel := fm! !

!FMFeature methodsFor: 'equality' stamp: 'AlexandreBergel 7/2/2012 11:00'!
hash
	^ self name hash! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 10:52'!
name
	^ name! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 10:52'!
name: anObject
	name := anObject! !

!FMFeature methodsFor: 'navigating' stamp: 'AlexandreBergel 7/2/2012 14:33'!
subFeatures
	<navigation: 'sub features'>
	subFeatures ifNotNil: [ ^ subFeatures ].
  
	^ subFeatures := featureModel subFeaturesOf: self! !

FMObject subclass: #FMFeatureExpr
	instanceVariableNames: 'feature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMFeatureExpr methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:15'!
accept: aVisitor
	feature accept: aVisitor
	! !

!FMFeatureExpr methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 10:57'!
feature
	^ feature! !

!FMFeatureExpr methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 10:57'!
feature: anObject
	feature := anObject! !

!FMFeatureExpr methodsFor: 'printing' stamp: 'AlexandreBergel 7/1/2012 10:45'!
printOn: str
	super printOn: str.
	str nextPut: $<.
	id ifNotNil: [ str nextPutAll: id ].
	str nextPut: $>.! !

FMFeatureExpr subclass: #FMFeatureMendatory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

FMFeatureExpr subclass: #FMFeatureMutex
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

FMFeatureExpr subclass: #FMFeatureOptional
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

FMFeatureExpr subclass: #FMFeatureOr
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

FMFeatureExpr subclass: #FMFeatureXor
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

FMObject subclass: #FMFeatureModel
	instanceVariableNames: 'exprs constraints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMFeatureModel methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 10:45'!
accept: aVisitor 
	aVisitor visitFeatureModel: self.
	exprs do: [ :expr | expr accept: aVisitor ]. 
	constraints do: [ :cons | cons accept: aVisitor ].! !

!FMFeatureModel methodsFor: 'adding' stamp: 'AlexandreBergel 7/2/2012 13:25'!
addAllConstraints: cons
	self assert: [ cons isCollection ].
	self assert: [ cons isEmpty or: [ cons first isKindOf: FMConstraintExpr ] ].
	constraints addAll: cons! !

!FMFeatureModel methodsFor: 'adding' stamp: 'AlexandreBergel 7/1/2012 15:22'!
addAllExpressions: exps
	exprs addAll: exps! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 14:50'!
constraintAt: index
	^ constraints at: index! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 14:44'!
featureNamed: aName 
	^ self features detect: [ :f | f name = aName ]! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:28'!
features
	| v |
	v := CountingFeatureVisitor new.
	self accept: v.
	v features do: [ :f | f featureModel: self ].
	^ v features! !

!FMFeatureModel methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/1/2012 14:26'!
initialize 
	super initialize.
	exprs := OrderedCollection new.
	constraints := OrderedCollection new! !

!FMFeatureModel methodsFor: 'printing' stamp: 'AlexandreBergel 7/2/2012 14:15'!
mooseNameOn: str 

	str nextPutAll: 'FM ('.
	exprs
		do: [ :expr | str nextPutAll: expr root name ].
	str nextPutAll: ')'.
	^ str contents! !

!FMFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 00:59'!
numberOfConstraints
	<MSEProperty: #numberOfConstraints type: #Number>
	^ constraints size! !

!FMFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 10:41'!
numberOfFeatures
	^ self features size! !

!FMFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 00:59'!
numberOfProductions
	<MSEProperty: #numberOfProductions type: #Number>
	^ exprs size! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 14:50'!
productionAt: index
	^ exprs at: index! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 14:45'!
subFeaturesOf: aFMFeature 
	^ ((exprs detect: [ :prod | prod root = aFMFeature ] ifNone: [ ^ #() ] ) allChildren collect: #feature) asArray! !

FMObject subclass: #FMFeatureProduction
	instanceVariableNames: 'root children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMFeatureProduction methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 10:50'!
accept: aVisitor
	root accept: aVisitor.
	children do: [ :child | child accept: aVisitor ] ! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:32'!
addAll: featureExpressions
	self assert: [ featureExpressions isCollection ].

	children addAll: featureExpressions! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:43'!
allChildren
	^ children copy! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:37'!
childAt: index
	^ children at: index! !

!FMFeatureProduction methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/1/2012 10:32'!
initialize
	super initialize.
	children := OrderedCollection new! !

!FMFeatureProduction methodsFor: 'metrics' stamp: 'AlexandreBergel 7/1/2012 10:37'!
numberOfChildren
	^ children size! !

!FMFeatureProduction methodsFor: 'printing' stamp: 'AlexandreBergel 7/1/2012 15:23'!
printOn: str
	super printOn: str.
	str nextPut: $<.
	id ifNotNil: [ str nextPutAll: root ].
	str nextPut: $>.! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:31'!
root
	^ root! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:31'!
root: anObject
	root := anObject! !

FMObject subclass: #FMProgram
	instanceVariableNames: 'statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMProgram methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:03'!
accept: aVisitor
	aVisitor visitProgram: self.
	self statements do: [ :s | s accept: aVisitor ]! !

!FMProgram methodsFor: 'adding' stamp: 'AlexandreBergel 7/1/2012 14:57'!
add: aStatement
	statements add: aStatement ! !

!FMProgram methodsFor: 'adding' stamp: 'AlexandreBergel 7/1/2012 15:06'!
addAll: ss
	ss do: [ :s | self add: s ]! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 15:09'!
featureNamed: aName
	| v t |
	v := CollectingVisitor new.
	self accept: v.
	t := (v elementsOfKind: FMFeature) select: [ :f | f name = aName ] .
	self assert: [ t size =  1 ].
	^ t first! !

!FMProgram methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/1/2012 14:57'!
initialize
	super initialize.
	statements := OrderedCollection new! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 16:24'!
lastStatement 
	^ statements last! !

!FMProgram methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 00:58'!
numberOfStatements
	<MSEProperty: #numberOfStatements type: #Number>
	^ statements size! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:08'!
statementAt: index
	^ statements at: index! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 00:14'!
statements
	^ statements copy! !

FMObject subclass: #FMStatement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

FMStatement subclass: #FMAssignment
	instanceVariableNames: 'variable featureModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMAssignment methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:16'!
accept: aVisitor
	aVisitor visitAssigment: self.
	
	aVisitor visitVariable: variable.
	featureModel accept: aVisitor.! !

!FMAssignment methodsFor: 'navigating' stamp: 'AlexandreBergel 7/2/2012 00:57'!
featureModel
	<navigation: 'Feature model'>
	^ featureModel! !

!FMAssignment methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:01'!
featureModel: anObject
	featureModel := anObject! !

!FMAssignment methodsFor: 'printing' stamp: 'AlexandreBergel 7/2/2012 00:49'!
mooseNameOn: str
	str nextPutAll: variable! !

!FMAssignment methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:01'!
variable
	^ variable! !

!FMAssignment methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:01'!
variable: anObject
	variable := anObject! !

!MooseModel methodsFor: '*familiar' stamp: 'AlexandreBergel 7/2/2012 15:44'!
allAssignments
	<navigation: 'All assigment'>
	^ FMAssignmentGroup 
		withAll: (self allWithType: FMAssignment )
		withDescription: 'Assignment'
	! !

!MooseModel methodsFor: '*familiar' stamp: 'AlexandreBergel 7/2/2012 01:05'!
allFeatureModels
	<navigation: 'All feature models'>
	^ FMFeatureModelGroup 
		withAll: (self allWithType: FMFeatureModel )
		withDescription: 'Feature models'
	! !

!MooseModel methodsFor: '*familiar' stamp: 'AlexandreBergel 7/2/2012 14:29'!
allFeatures
	<navigation: 'All features'>
	^ FMFeatureGroup 
		withAll: (self allWithType: FMFeature )
		withDescription: 'Features'
	! !

MooseGroup subclass: #FMAssignmentGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMAssignmentGroup commentStamp: '<historical>' prior: 0!
MooseModel resetMeta!

!FMAssignmentGroup class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 15:44'!
annotation

	<MSEClass: #AssignmentGroup super: #MooseGroup>
	<package: #Familiar>
! !

!FMAssignmentGroup methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/2/2012 15:45'!
viewComplexity
	<menuItem: 'Complexity' category: 'Visualize'>
	
	"Preambule. It includes the initialization. "
	| view |
	view := ROMondrianViewBuilder new.
	"enter your script below"
	"-------------"
	"-------------"

	view interaction popupText: #variable; action: #inspect.
	"view shape rectangle 
		linearFillColor: [ :ass | ass featureModel numberOfConstraints] within: AS."
	view nodes: AS forEach: [ :ass |
		| fm |
		 fm := ass featureModel.

		view nodes: fm features.
		view edges: fm features from: #yourself toAll: #subFeatures.
		view treeLayout 
	].
	"-------------"
	"-------------"
	"Below is the initiation of the menu and opening the visualization"
	ROEaselMorphic new populateMenuOn: view.
	view open! !

MooseGroup subclass: #FMFeatureGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMFeatureGroup class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 14:29'!
annotation

	<MSEClass: #FeatureGroup super: #MooseGroup>
	<package: #Familiar>
! !

!FMFeatureGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/2/2012 14:59'!
viewComplexity
	<menuItem: 'Complexity' category: 'Visualize'>

	"Preambule. It includes the initialization. "
	| view nodes |
	view := ROMondrianViewBuilder new.
	"enter your script below"
	"-------------"
	"-------------"

	nodes := self asArray.
	view interaction action: #inspect; popupText.

	view nodes: nodes.
	view edges: nodes from: #yourself toAll:  #subFeatures.
	view treeLayout.
	"-------------" 
	"-------------"
	"Below is the initiation of the menu and opening the visualization"
	ROEaselMorphic new populateMenuOn: view.
	view open! !

MooseGroup subclass: #FMFeatureModelGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMFeatureModelGroup class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 01:12'!
annotation

	<MSEClass: #FeatureModelGroup super: #MooseGroup>
	<package: #Familiar>
! !

!FMFeatureModelGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/2/2012 10:25'!
viewDistribution
	<menuItem: 'Distribution' category: 'Visualize'>
	
	| view | 
	view := MOViewRenderer new.
	view shape rectangle 
			width: [ :fm | fm numberOfProductions * 5 ];
			height: [ :fm | fm numberOfConstraints * 5 ].
	view nodes: self entities.
	^ view openWithStatusbar title: 'Class Blueprint'! !

Object subclass: #FMParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

FMParser subclass: #FMASTBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:31'!
children
	^ super children ==> [ :node | node flatten ]! !

!FMASTBuilder methodsFor: 'public' stamp: 'AlexandreBergel 7/2/2012 13:28'!
constraint
	| term prim |
	
	term := PPDelegateParser new.
	prim := PPDelegateParser new.
	
	term setParser: ((prim trim,  self constraintOperator , prim) ==> [ :n |  n second new left: n first ; right: n third; yourself  ] )/ 
					prim.
	prim setParser: 
		(self fmlIdentifier trim ==> [ :n | "FMConstraintValue new feature: " n ]) /
		(($( asParser trim , term , $) asParser trim) /
					($!! asParser trim, term) ==> [ :n | FMConstraintNegated new expr: n second ])
				.
					
	^ term! !

!FMASTBuilder methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 10:01'!
constraintOperator
	^ ( '|'  asParser trim / 
						'&' asParser trim / 
						'->' asParser trim  /  
						'<->' asParser trim) ==> [ :n | FMConstraintBinOp for: n ] ! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 14:39'!
featureModel
	^ super featureModel ==> [ :node | 
		| prods cons fm |
		prods := node third collect: #first. 
		cons := node fourth flatten reject: [ :n | n = $; ]. 
		
		fm := FMFeatureModel new 
			addAllExpressions: prods;
			addAllConstraints: cons;
			yourself.
		fm features do: [ :f | f featureModel: fm ].
		fm ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 10:56'!
fmlIdentifier
	^ super fmlIdentifier ==> [ :node | FMFeature new name: node ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 13:26'!
mandatory
	^ super mandatory ==> [ :node | Array with: (FMFeatureMendatory new feature: node) ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:27'!
mutexgroup
	^ super mutexgroup ==> [ :node | 
		| featureNames |
		featureNames := OrderedCollection new.
		featureNames add: node second.
		featureNames addAll: (node third collect: #second).
		featureNames collect: [ :n | FMFeatureMutex new feature: n ] ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:28'!
optional
	^ super optional ==> [ :node |  Array with: (FMFeatureOptional new feature: node second) ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:21'!
orgroup
	^ super orgroup ==> [ :node | 
		| featureNames |
		featureNames := OrderedCollection new.
		featureNames add: node second.
		featureNames addAll: (node third collect: #second).
		featureNames collect: [ :n | FMFeatureOr new feature: n ] ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:58'!
production
	^ super production ==> [ :nodes | 
		FMFeatureProduction new 
			root: nodes first ; 
			addAll: nodes third ; 
			yourself ]
! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:59'!
xorgroup
	^ super xorgroup ==> [ :node | 
		| featureNames |
		featureNames := OrderedCollection new.
		featureNames add: node second.
		featureNames addAll: (node third collect: #second).
		featureNames collect: [ :n | FMFeatureXor new feature: n ] ]! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 13:05'!
child
	^ self mandatory / self orgroup / self mutexgroup / self optional / self xorgroup ! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 10:56'!
children
	^ self child plus! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 09:38'!
constraint
	| term prim |
	
	term := PPDelegateParser new.
	prim := PPDelegateParser new.
	
	term setParser: ( prim,  ( '|'  asParser trim / '&' asParser trim / '->' asParser trim  /  '<->' asParser trim ) , prim) / 
					prim.
	prim setParser: ($( asParser trim , term , $) asParser trim) /
					($!! asParser trim, term) /
				self id.
					
	^ term! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 15:22'!
featureModel
	
	^ 'FM' asParser trim , self leftPar ,  ((self production  , self semiColumn ) plus) ,  (self constraint  , self semiColumn ) star , self rightPar
! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 14:14'!
fmlIdentifier
	^ (#letter asParser , ( #letter asParser / #digit asParser ) star) flatten trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 11:03'!
id
	^  (#letter asParser , ( #letter asParser / #digit asParser ) star) flatten trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 6/30/2012 22:13'!
leftPar 
	^ $( asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:47'!
mandatory
	"Mandatory   : name=ID ;
	ID : ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*; "
	
	^ self fmlIdentifier ! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:35'!
mutexgroup
	"Mutexgroup   : LEFT_PAREN features+=ID  ('|' features+=ID)+ RIGHT_PAREN '?' ;"

	^ $( asParser , self fmlIdentifier  , ( $| asParser , self fmlIdentifier ) plus ,  $) asParser , $? asParser! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 11:51'!
optional
	"Optional    : '[' name=FML_IDENTIFIER ']' ;"
	^ '[' asParser trim , self fmlIdentifier , ']' asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:35'!
orgroup
	"Orgroup    : LEFT_PAREN features+=ID  ('|' features+=ID)+ RIGHT_PAREN '+' ;"

	^ self leftPar  , self fmlIdentifier , ( self verticalBar  , self fmlIdentifier ) plus ,  self rightPar  , $+ asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 10:56'!
production
	^ (self fmlIdentifier ,  ':' asParser trim , self children) trim! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 15:06'!
program
	^ self statement star ==> [ :node | FMProgram new addAll: node ]! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 6/30/2012 22:14'!
rightPar 
	^ $) asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 01:59'!
semiColumn
	^ $; asParser trim! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 15:05'!
statement
	^ (self id , $= asParser trim, self featureModel) ==>
			 [ :node | FMAssignment new variable: node first; featureModel: node third ]! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 01:58'!
verticalBar 
	^ $| asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 13:03'!
xorgroup
	"Xorgroup   : LEFT_PAREN features+=ID  ('|' features+=ID)+ RIGHT_PAREN ;"

	^ self leftPar , self fmlIdentifier , ( self verticalBar , self fmlIdentifier ) plus ,  self rightPar! !

Object subclass: #FMVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

FMVisitor subclass: #CollectingVisitor
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!CollectingVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 14:27'!
elements
	^ elements asSet asOrderedCollection! !

!CollectingVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 15:06'!
elementsOfKind: aClass
	^ self elements select: [ :el | el isKindOf: aClass ]! !

!CollectingVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 00:22'!
initialize 
	super initialize.
	elements := OrderedCollection new ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:21'!
visitAssigment: aFMAssignment 
	elements add: aFMAssignment ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 14:26'!
visitFeature: aFMFeature 
	elements add: aFMFeature ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:21'!
visitFeatureModel: aFMFeatureModel 
	elements add: aFMFeatureModel ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:21'!
visitProgram: aFMProgram 
	elements add: aFMProgram ! !

FMVisitor subclass: #CountingFeatureVisitor
	instanceVariableNames: 'features'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar'!

!CountingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:18'!
features 
	^ features asArray! !

!CountingFeatureVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 10:49'!
initialize
	super initialize.
	features := OrderedCollection new.! !

!CountingFeatureVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:19'!
visitFeature: aFMFeature 
	(features includes: aFMFeature)
		ifFalse: [ features add: aFMFeature ]! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:15'!
visitAssigment: aFMAssignment 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 13:30'!
visitConstraintNegated: aFMConstraintNegated 
! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:13'!
visitFeature: aFMFeature 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:17'!
visitFeatureModel: aFMFeatureModel 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:14'!
visitProgram: aFMProgram 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:16'!
visitVariable: aVariable 
	! !
